<?php

class DispletRetsIdxUrlStructure{
	function create_global_model() {
		$displetretsidx_option = DispletRetsIdxSettings::get_option();
		global $displetretsidx_global_model;
		$displetretsidx_global_model['options'] = $displetretsidx_option;
		if (is_page($displetretsidx_option['property_details_page_id'])) {
			$displetretsidx_global_model = array(
				'options' => $displetretsidx_option,
				'is_displet_api' => (!empty($displetretsidx_option['displet_app_key'])) ? true : false,
				'app_key' => $displetretsidx_option['displet_app_key'],
				'property_id' => get_query_var('property_id'),
				'property_zip' => get_query_var('property_zip'),
				'property_city' => get_query_var('property_city'),
				'property_state' => get_query_var('property_state'),
				'page_id' => $displetretsidx_option['property_details_page_id'],
				'last_updated' => date('Y-m-d', strtotime('-12 hours'))
			);
			if (!empty($displetretsidx_global_model['property_id'])) {
				$displetretsidx_global_model['google_auth_url'] = DispletRetsIdxGoogle::get_authorization_url();
				// Get raw data from json API server-side for crawlable content - creating global to only ping API once and use the data across various WP hooks
				$listing = DispletRetsIdxQuery::get_listing($displetretsidx_global_model);
				$displetretsidx_global_model = array_merge($displetretsidx_global_model, $listing);
			}
			else {
				if (!empty($displetretsidx_global_model['property_state']) || !empty($displetretsidx_global_model['property_city']) || !empty($displetretsidx_global_model['property_zip'])) {
					$displetretsidx_global_model['region'] = stripslashes($displetretsidx_global_model['options']['oodle_region']);
					$displetretsidx_global_model['category'] = stripslashes($displetretsidx_global_model['options']['oodle_category']);
					$displetretsidx_global_model['listings_per_page'] = intval($displetretsidx_global_model['options']['listings_per_page']);
					$displetretsidx_global_model['orientation'] = stripslashes($displetretsidx_global_model['options']['listings_orientation']);
					$displetretsidx_global_model['sort'] = stripslashes($displetretsidx_global_model['options']['listings_sort']);
					$displetretsidx_global_model['return_fields'] = 'city,full_baths,half_baths,primary_big_image_urls,internet_remarks,latitude,list_price,longitude,mls_number,num_bedrooms,property_type,square_feet,state,street_name,street_number,street_post_dir,street_pre_direction,sysid,zip';
					if (!empty($displetretsidx_global_model['options']['include_subdivision'])) {
						$model['return_fields'] .= ',subdivision';
					}
					if (!empty($displetretsidx_global_model['options']['include_listing_agent'])) {
						$model['return_fields'] .= ',listing_agent_name';
					}
					if (!empty($displetretsidx_global_model['options']['include_listing_office'])) {
						$model['return_fields'] .= ',listing_office_name';
					}
					$displetretsidx_global_model['previous_page_url'] = '#prev';
					$displetretsidx_global_model['next_page_url'] = '#next';
					if (!empty($displetretsidx_global_model['property_zip'])){
						$displetretsidx_global_model['zip'] = $displetretsidx_global_model['property_zip'];
					}
					else if (!empty($displetretsidx_global_model['property_city'])){
						$displetretsidx_global_model['city'] = str_replace('-', '%20', $displetretsidx_global_model['property_city']);
					}
					else if (!empty($displetretsidx_global_model['property_state'])){
						$displetretsidx_global_model['keyword'] = str_replace('-', '%20', $displetretsidx_global_model['property_state']);
					}
					$displetretsidx_global_model['query_url'] = DispletRetsIdxQuery::get_query_url($displetretsidx_global_model);
					if (!empty($displetretsidx_global_model['property_city'])){
						$displetretsidx_global_model['city'] = str_replace('-', ' ', $displetretsidx_global_model['property_city']);
					}
					else if (!empty($displetretsidx_global_model['property_state'])){
						$displetretsidx_global_model['keyword'] = str_replace('-', ' ', $displetretsidx_global_model['property_state']);
					}
					// Get raw data from json API server-side for crawlable content
					$listings = DispletRetsIdxQuery::get_listings($displetretsidx_global_model);
					$displetretsidx_global_model = array_merge($displetretsidx_global_model, $listings);
				}
			}
		}
	}

	function replace_wp_title($title) {
		global $displetretsidx_global_model;
		if (is_page($displetretsidx_global_model['page_id'])) {
			if (!empty($displetretsidx_global_model['property_id'])) {
				$title = $displetretsidx_global_model['listings'][0]->address;
				if (!empty($displetretsidx_global_model['listings'][0]->city)) {
					$title .= ', ' . $displetretsidx_global_model['listings'][0]->city;
				}
				if (!empty($displetretsidx_global_model['listings'][0]->state)) {
					$title .= ', ' . $displetretsidx_global_model['listings'][0]->state;
				}
				if (!empty($displetretsidx_global_model['listings'][0]->zip)) {
					$title .= ' ' . $displetretsidx_global_model['listings'][0]->zip;
				}
			}
			else if (!empty($displetretsidx_global_model['property_zip'])) {
				$title = $displetretsidx_global_model['zip'];
			}
			else if (!empty($displetretsidx_global_model['property_city'])) {
				$title = $displetretsidx_global_model['city'];
			}
			else if (!empty($displetretsidx_global_model['property_state'])) {
				$title = $displetretsidx_global_model['keyword'];
			}
		}
		return $title;
	}

	function replace_page_title($title) {
		global $displetretsidx_global_model, $post, $id;
		if (is_page($displetretsidx_global_model['page_id']) && $id == $post->ID && in_the_loop() && self::is_referral_function('the_title')) {
			if (!empty($displetretsidx_global_model['property_id'])) {
				$title = DispletRetsIdxLoad::get_template('displet-property-details-page-title.php', $displetretsidx_global_model);
			}
			else if (!empty($displetretsidx_global_model['property_zip'])) {
				$title = DispletRetsIdxLoad::get_template('displet-listings-page-title.php', $displetretsidx_global_model);
			}
			else if (!empty($displetretsidx_global_model['property_city'])) {
				$title = DispletRetsIdxLoad::get_template('displet-listings-page-title.php', $displetretsidx_global_model);
			}
			else if (!empty($displetretsidx_global_model['property_state'])) {
				$title = DispletRetsIdxLoad::get_template('displet-listings-page-title.php', $displetretsidx_global_model);
			}
		}
		return $title;
	}

	function replace_page_content($content) {
		global $displetretsidx_global_model;
		if (is_page($displetretsidx_global_model['page_id']) && in_the_loop()) {
			if (!empty($displetretsidx_global_model['property_id'])) {
				$content = '<!-- Displet Property ID: ' . $displetretsidx_global_model['property_id'] . ' -->';
				$content .= DispletRetsIdxLoad::get_template('displet-facebook-login-jquery.php', $displetretsidx_global_model);
				$content .= DispletRetsIdxLoad::get_template('displet-property-details-page-jquery.php', $displetretsidx_global_model);
				$content .= DispletRetsIdxLoad::get_template('displet-property-details-page-content.php', $displetretsidx_global_model);
				$content .= DispletRetsIdxLoad::get_template('displet-property-details-page-popups.php', $displetretsidx_global_model);
				$content .= DispletRetsIdxLoad::get_template('displet-login-register-popup.php', $displetretsidx_global_model);
				$url = 'http://' . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI'];
				$base = get_permalink($displetretsidx_global_model['property_details_page_id']);
				$url = str_replace($base, '', $url);
				DispletRetsIdxUsers::update_viewed_properties($url, $displetretsidx_global_model['listings'][0]->address, $displetretsidx_global_model['listings'][0]->list_price, $displetretsidx_global_model['listings'][0]->zip, $displetretsidx_global_model['listings'][0]->square_feet);
			}
			else {
				if (!empty($displetretsidx_global_model['property_zip'])){
					$content = '<!-- Displet Property Zip: ' . $displetretsidx_global_model['zip'] . ' -->';
					$content .= DispletRetsIdxLoad::get_template('displet-property-unavailable-jquery.php', $displetretsidx_global_model);
				}
				else if (!empty($displetretsidx_global_model['property_city'])){
					$content = '<!-- Displet Property City: ' . $displetretsidx_global_model['city'] . ' -->';
				}
				else if (!empty($displetretsidx_global_model['property_state'])){
					$content = '<!-- Displet Property State: ' . $displetretsidx_global_model['keyword'] . ' -->';
				}
				if (!empty($displetretsidx_global_model['property_state']) || !empty($displetretsidx_global_model['property_city']) || !empty($displetretsidx_global_model['property_zip'])) {
					if (intval($displetretsidx_global_model['meta']->count) > 0) {
						$content .= DispletRetsIdxLoad::get_template('displet-listings-jquery.php', $displetretsidx_global_model);
						if ($displetretsidx_global_model['is_displet_api']) {
							if ((!empty($displetretsidx_global_model['options']['include_property_type_navigation']) || !empty($displetretsidx_global_model['options']['include_property_type_sorting'])) && intval($displetretsidx_global_model['meta']->count) > 9){
								$displetretsidx_global_model['property_types'] = DispletRetsIdxListings::get_property_type_navigation($displetretsidx_global_model);
							}
							if (!empty($displetretsidx_global_model['options']['include_property_type_navigation']) && intval($displetretsidx_global_model['meta']->count) > 9) {
								$content .= DispletRetsIdxLoad::get_template('displet-property-type-navigation.php', $displetretsidx_global_model);
							}
							if (!empty($displetretsidx_global_model['options']['include_price_navigation']) && intval($displetretsidx_global_model['meta']->count) > 9) {
								$content .= DispletRetsIdxLoad::get_template('displet-price-navigation.php', $displetretsidx_global_model);
							}
							if (!empty($displetretsidx_global_model['options']['include_stats'])){
								$content .= DispletRetsIdxLoad::get_template('displet-statistics.php', $displetretsidx_global_model);
							}
						}
					}
					$displetretsidx_global_model['sort_options'] = DispletRetsIdxListings::get_sort_options($displetretsidx_global_model);
					$content .= DispletRetsIdxLoad::get_template('displet-dynamic.php', $displetretsidx_global_model);
				}
				if ($displetretsidx_global_model['options']['allow_sitewide_registration'] == '1' && in_the_loop()) {
					$content .= DispletRetsIdxLoad::get_template('displet-login-register-popup.php', $displetretsidx_global_model);
				}
			}
		}
		return $content;
	}

	function generate_rewrite_rules(){
		$displetretsidx_option = DispletRetsIdxSettings::get_option();
		$id = $displetretsidx_option['property_details_page_id'];
		$pagename = get_page($id)->post_name;
		$rule = $pagename . '/([^/]+)/?([^/]*)/?([^/]*)/?([^/]*)/?([^/]*)/?$';
		$rewrite = 'index.php?pagename=' . $pagename . '&property_state=$matches[1]&property_city=$matches[2]&property_zip=$matches[3]&property_id=$matches[4]&property_address=$matches[5]';
		$property_state_tag = '%property_state%';
		$property_city_tag = '%property_city%';
		$property_zip_tag = '%property_zip%';
		$property_address_tag = '%property_address%';
		$property_id_tag = '%property_id%';
		$args = array(
			'paged' => false
		);
		add_rewrite_tag($property_state_tag, $rule);
		add_rewrite_tag($property_city_tag, $rule);
		add_rewrite_tag($property_zip_tag, $rule);
		add_rewrite_tag($property_address_tag, $rule);
		add_rewrite_tag($property_id_tag, $rule);
		add_rewrite_rule($rule, $rewrite, 'top');
	}

	function flush_rewrite_rules(){
		$rules = get_option('rewrite_rules');
		$displetretsidx_option = DispletRetsIdxSettings::get_option();
		$id = $displetretsidx_option['property_details_page_id'];
		$pagename = get_page($id)->post_name;
		if (!isset($rules[$pagename . '/([^/]+)/?([^/]*)/?([^/]*)/?([^/]*)/?([^/]*)/?$'])){
			global $wp_rewrite;
		   	$wp_rewrite->flush_rules();
		}
	}

	function replace_canonical(){
		global $displetretsidx_global_model;
		if (!empty($displetretsidx_global_model['property_id']) || !empty($displetretsidx_global_model['property_state']) || !empty($displetretsidx_global_model['property_city']) || !empty($displetretsidx_global_model['property_zip'])) {
			remove_action('wp_head', 'rel_canonical');
			add_action('wp_head', array('DispletRetsIdxUrlStructure', 'new_canonical'), 1);
		}
	}

	function new_canonical(){
		global $displetretsidx_global_model;
		if (!empty($displetretsidx_global_model['property_id'])) {
	    	$link = $displetretsidx_global_model['listings'][0]->permalink;
		}
		else if (!empty($displetretsidx_global_model['property_zip'])) {
	    	$link = rtrim(get_permalink($displetretsidx_global_model['page_id']), '/') . '/' .
	    		stripslashes(str_replace(' ', '-', $displetretsidx_global_model['property_state'])) . '/' .
	    		stripslashes(str_replace(' ', '-', $displetretsidx_global_model['property_city'])) . '/' .
	    		stripslashes(str_replace(' ', '-', $displetretsidx_global_model['property_zip']));
		}
		else if (!empty($displetretsidx_global_model['property_city'])) {
	    	$link = rtrim(get_permalink($displetretsidx_global_model['page_id']), '/') . '/' .
	    		stripslashes(str_replace(' ', '-', $displetretsidx_global_model['property_state'])) . '/' .
	    		stripslashes(str_replace(' ', '-', $displetretsidx_global_model['property_city']));
		}
		else if (!empty($displetretsidx_global_model['property_state'])) {
	    	$link = rtrim(get_permalink($displetretsidx_global_model['page_id']), '/') . '/' .
	    		stripslashes(str_replace(' ', '-', $displetretsidx_global_model['property_state']));
		}
	    echo '<link rel="canonical" href="' . esc_url($link) . '" />' . "\n";
	}

	function remove_yoasts_canonical($canonical) {
		global $displetretsidx_global_model, $post;
		if (!empty($displetretsidx_global_model['property_id']) || !empty($displetretsidx_global_model['property_zip']) || !empty($displetretsidx_global_model['property_city']) || !empty($displetretsidx_global_model['property_state'])) {
	    	$canonical = false;
	    }
		return $canonical;
	}

	// Whitelist query var for Yoast's redirect option
	/* Should work but doesn't :-( - $_GET['property_id'] fails in Yoast's code, whereas get_query_var('property_id') doesn't
	function whitelist_query_var_from_yoasts_redirect($whitelisted_extravars) {
		$whitelisted_extravars = array('property_id');
		return $whitelisted_extravars;
	}
	*/

	function redirect_to_canonical(){
		global $displetretsidx_global_model;
		if (!empty($displetretsidx_global_model['property_id']) && !empty($displetretsidx_global_model['property_zip']) && !empty($displetretsidx_global_model['property_city']) && !empty($displetretsidx_global_model['property_state']) && !empty($displetretsidx_global_model['listings'][0]->permalink)) {
			//$current_url = rtrim(home_url($_SERVER['REQUEST_URI']), '/');
			//if ($displetretsidx_global_model['listings'][0]->permalink != $current_url) {
			$trimmed_url_end = rtrim($_SERVER['REQUEST_URI'], '/');
			if (strpos($displetretsidx_global_model['listings'][0]->permalink, $trimmed_url_end) === false) {
				wp_safe_redirect($displetretsidx_global_model['listings'][0]->permalink, 301);
			}
		}
	}

	function redirect_to_parent(){
		global $displetretsidx_global_model;
		if (is_page($displetretsidx_global_model['page_id']) && !empty($displetretsidx_global_model['property_id'])) {
			if (empty($displetretsidx_global_model['listings'][0])) {
				$property_address = get_query_var('property_address');
	    		$link = rtrim(get_permalink($displetretsidx_global_model['page_id']), '/') . '/' .
	    			stripslashes(str_replace(' ', '-', $displetretsidx_global_model['property_state'])) . '/' .
	    			stripslashes(str_replace(' ', '-', $displetretsidx_global_model['property_city'])) . '/' .
	    			stripslashes(str_replace(' ', '-', $displetretsidx_global_model['property_zip'])) . '#listing=' . $displetretsidx_global_model['property_id'] . '/';
	    		if (!empty($property_address)) {
	    			$link .= 'address=' . $property_address . '/';
	    		}
	    		$link .= 'status=unavailable';
	    		wp_safe_redirect($link, 301);
			}
			else{
				self::redirect_to_canonical();
			}
		}
	}

	// Determine referral function (useful to prevent unintentional title adjustments in menus)
	function is_referral_function($f) {
		$aray = debug_backtrace(DEBUG_BACKTRACE_IGNORE_ARGS);
		foreach($aray as $a) {	$aa[] = $a["function"];	}
		if(in_array($f,$aa)) { return true; }
		return false;
	}

}

// Hooking pre_get_posts for create_global_model is too soon for some themes/servers
add_action('wp', array('DispletRetsIdxUrlStructure', 'create_global_model'));
add_filter('wp_title', array('DispletRetsIdxUrlStructure', 'replace_wp_title'), 1000000);
add_filter('the_title', array('DispletRetsIdxUrlStructure', 'replace_page_title'));
add_filter('the_content', array('DispletRetsIdxUrlStructure', 'replace_page_content'));
add_action('init', array('DispletRetsIdxUrlStructure', 'generate_rewrite_rules'));
add_action('wp_loaded', array('DispletRetsIdxUrlStructure', 'flush_rewrite_rules'));
add_action('template_redirect', array('DispletRetsIdxUrlStructure', 'replace_canonical'));
add_action('template_redirect', array('DispletRetsIdxUrlStructure', 'redirect_to_parent'), 1);
add_filter('wpseo_canonical', array('DispletRetsIdxUrlStructure', 'remove_yoasts_canonical'));
//add_filter('wpseo_whitelist_permalink_vars', array('DispletRetsIdxUrlStructure', 'whitelist_query_var_from_yoasts_redirect'));

?>