<?php

/*
 * Plugin name: Displet Beta
 * Plugin URI: http://displet.com/wordpress-plugins/displet-rets-idx-plugin/
 * Description: Beta plugin.
 * Version: 1.0.8
 * Author: Displet
 * Author URI: http://displet.com/
 * License: GPL2
 */

/*  Copyright 2011 Displet (email : dev@displet.com)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License, version 2, as 
 *  published by the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

class DispletRetsIdxPlugin{
    public function add_version(){
        echo '<!-- Displet RETS/IDX Beta v. 1.0.8 -->';
    }

    public function register_default_settings(){
	    $has_default_page = get_page_by_path('rets');
	    if (!$has_default_page) {    
	        $displet_default_rets_idx_page = array(
	          'post_name' => 'rets',
	          'post_title' => 'Real Estate',
	          'post_type' => 'page',
	          'post_status' => 'publish'
	        );
	        wp_insert_post($displet_default_rets_idx_page);
	    }
	    $default_page = get_page_by_path('rets');
		$admin_email = get_bloginfo('admin_email');
		$default_emails = self::get_default_emails();
		$displet_rets_idx_option = array(
			'address_format' => '%%street_number%% %%street_pre_direction%% %%street_name%% %%street_post_direction%% #%%unit%%',
			'allowed_public_views' => 0,
			'allow_sitewide_registration' => 0,
			'color_scheme' => 'default',
			'email' => $admin_email,
			'email_from_address' => $admin_email,
			'email_from_name' => get_bloginfo('name'),
			'email_signature' => $default_emails['email_signature'],
			'email_title_new_registration_to_user' => $default_emails['email_title_new_registration_to_user'],
			'email_template_new_registration_to_user' => $default_emails['email_template_new_registration_to_user'],
			'email_title_new_registration_to_admin' => $default_emails['email_title_new_registration_to_admin'],
			'email_template_new_registration_to_admin' => $default_emails['email_template_new_registration_to_admin'],
			'email_title_property_showing_to_user' => $default_emails['email_title_property_showing_to_user'],
			'email_template_property_showing_to_user' => $default_emails['email_template_property_showing_to_user'],
			'email_title_property_showing_to_admin' => $default_emails['email_title_property_showing_to_admin'],
			'email_template_property_showing_to_admin' => $default_emails['email_template_property_showing_to_admin'],
			'email_title_email_friend_to_user' => $default_emails['email_title_email_friend_to_user'],
			'email_template_email_friend_to_user' => $default_emails['email_template_email_friend_to_user'],
			'email_title_email_friend_to_admin' => $default_emails['email_title_email_friend_to_admin'],
			'email_template_email_friend_to_admin' => $default_emails['email_template_email_friend_to_admin'],
			'exclude_referred_visitors' => 1,
			'include_listing_office' => 1,
			'include_price_navigation' => 1,
			'include_stats' => 1,
			'include_subdivision' => 1,
			'listings_orientation' => 'gallery',
			'listings_sort' => 'price-descending',
			'listings_per_page' => '10',
			'oodle_region' => 'usa',
			'oodle_category' => 'housing/sale',
			'map_variance' => 2,
			'no_link' => 0,
			'property_details_page_id' => $default_page->ID,
			'search_results_page_id' => $default_page->ID,
			'search_values_property_types' => array(
				'House' => 'true',
				'Condo' => 'true',
				'Lease' => 'true',
				'Land' => 'true',
				'Multi' => 'true',
				'Ranch' => 'true'
			),
			'search_values_min_price' => '100',
			'search_values_max_price' => '1000',
			'search_values_price_increment' => '50',
			'search_values_beds_min' => '1',
			'search_values_beds_max' => '6',
			'search_values_baths_min' => '1',
			'search_values_baths_max' => '6',
			'search_values_min_square_feet' => '500',
			'search_values_max_square_feet' => '5000',
			'search_values_square_feet_increment' => '500',
			'search_values_min_acres' => .25,
			'search_values_max_acres' => 5,
			'search_values_acres_increment' => .25,
		);
		add_option('displet_rets_idx_options', $displet_rets_idx_option);
	}

	private function get_default_emails(){
		$default_emails = array();
		$default_emails['email_signature'] =
			'Thanks,' . "\r\n" .
			'%%site_name%%' . "\r\n" .
			'%%site_url%%';
		$default_emails['email_title_new_registration_to_user'] =
			'New Account Details for %%site_url%%';
		$default_emails['email_template_new_registration_to_user'] =
			'Thank you for registering at %%site_url%%.' . "\r\n\r\n" .
			'Name: %%user_name%%' . "\r\n" .
			'Email: %%user_email%%' . "\r\n" .
			'Phone: %%user_phone%%' . "\r\n" .
			'Username: %%user_username%%' . "\r\n" .
			'Password: %%user_password%%' . "\r\n";
		$default_emails['email_title_new_registration_to_admin'] =
			'A New User Has Registered at %%site_url%%';
		$default_emails['email_template_new_registration_to_admin'] =
			'A new user has registered at %%site_url%%.' . "\r\n\r\n" .
			'Name: %%user_name%%' . "\r\n" .
			'Email: %%user_email%%' . "\r\n" .
			'Phone: %%user_phone%%' . "\r\n" .
			'Registered at: %%registration_url%%' . "\r\n";
		$default_emails['email_title_property_showing_to_user'] =
			'Property Showing Request Received for %%property_address%%';
		$default_emails['email_template_property_showing_to_user'] =
			'%%property_url%%' . "\r\n\r\n" .
			'Property: %%property_address%%' . "\r\n" .
			'Name: %%user_name%%' . "\r\n" .
			'Email: %%user_email%%' . "\r\n" .
			'Phone: %%user_phone%%' . "\r\n" .
			'Appointment 1 %%user_appointment%%: ' . "\r\n" .
			'Appointment 2: %%user_appointment2%%' . "\r\n" .
			'Message: %%user_message%%';
		$default_emails['email_title_property_showing_to_admin'] =
			'Property Showing Request for %%property_address%%';
		$default_emails['email_template_property_showing_to_admin'] =
			'%%property_url%%' . "\r\n\r\n" .
			'Property %%property_address%%: ' . "\r\n" .
			'Name: %%user_name%%' . "\r\n" .
			'Email: %%user_email%%' . "\r\n" .
			'Phone: %%user_phone%%' . "\r\n" .
			'Appointment 1 %%user_appointment%%: ' . "\r\n" .
			'Appointment 2: %%user_appointment2%%' . "\r\n" .
			'Message: %%user_message%%';
		$default_emails['email_title_email_friend_to_user'] =
			'%%user_name%% Thinks You\'ll Like %%property_address%%';
		$default_emails['email_template_email_friend_to_user'] =
			'%%property_url%%' . "\r\n\r\n" .
			'Property: %%property_address%%' . "\r\n" .
			'Message from %%user_name%%: %%user_message%%';
		$default_emails['email_title_email_friend_to_admin'] =
			'Property Emailed To A Friend from %%site_url%%';
		$default_emails['email_template_email_friend_to_admin'] =
			'%%property_url%%' . "\r\n\r\n" .
			'Property: %%property_address%% ' . "\r\n" .
			'Friend Name: %%friend_name%%' . "\r\n" .
			'Friend Email: %%friend_email%%' . "\r\n" .
			'User Name: %%user_name%%' . "\r\n" .
			'User Email: %%user_email%%' . "\r\n" .
			'User Message: %%user_message%%';
		return $default_emails;
	}

	public function register_default_widgets(){
		$widgets = get_option('widget_displetretsidxsearchfield');
		if (empty($widgets[1])) {
			$widgets[1] = array(
				'title' => 'Property Type',
				'field' => 'property_type'
			);
		}
		if (empty($widgets[2])) {
			$widgets[2] = array(
				'title' => 'Price Min/Max',
				'field' => 'price'
			);
		}
		if (empty($widgets[3])) {
			$widgets[3] = array(
				'title' => 'Beds/Baths',
				'field' => 'beds_baths'
			);
		}
		if (empty($widgets[4])) {
			$widgets[4] = array(
				'title' => 'City, Zip, Neighborhood, or Condo',
				'field' => 'quick_terms'
			);
		}
		if (empty($widgets[5])) {
			$widgets[5] = array(
				'title' => 'Keywords: Ex. Pool, Modern, Foreclosure',
				'field' => 'keywords'
			);
		}
		if (empty($widgets[6])) {
			$widgets[6] = array(
				'title' => 'Foreclosure',
				'field' => 'foreclosure'
			);
		}
		if (empty($widgets[7])) {
			$widgets[7] = array(
				'title' => 'School District',
				'field' => 'school_district'
			);
		}
		if (empty($widgets[8])) {
			$widgets[8] = array(
				'title' => 'School',
				'field' => 'school'
			);
		}
		if (empty($widgets[9])) {
			$widgets[9] = array(
				'title' => 'Pool',
				'field' => 'pool'
			);
		}
		if (empty($widgets[10])) {
			$widgets[10] = array(
				'title' => 'Waterfront',
				'field' => 'waterfront'
			);
		}
		if (empty($widgets[11])) {
			$widgets[11] = array(
				'title' => 'Property Type',
				'field' => 'property_type'
			);
		}
		if (empty($widgets[12])) {
			$widgets[12] = array(
				'title' => 'Price Min/Max',
				'field' => 'price'
			);
		}
		if (empty($widgets[13])) {
			$widgets[13] = array(
				'title' => 'Beds/Baths',
				'field' => 'beds_baths'
			);
		}
		if (empty($widgets[14])) {
			$widgets[14] = array(
				'title' => 'City, Zip, Neighborhood, or Condo',
				'field' => 'quick_terms'
			);
		}
		if (empty($widgets[15])) {
			$widgets[15] = array(
				'title' => 'Keywords: Ex. Pool, Modern, Foreclosure',
				'field' => 'keywords'
			);
		}
		update_option('widget_displetretsidxsearchfield', $widgets);
	}

	public function register_default_widget_areas_content(){
		$sidebars = get_option('sidebars_widgets');
		$need_sidebars_update = false;
		if (empty($sidebars['displetretsidx-search-form-1'])) {
			$need_sidebars_update = true;
			$sidebars['displetretsidx-search-form-1'] = array(
				'displetretsidxsearchfield-1',
				'displetretsidxsearchfield-2',
				'displetretsidxsearchfield-3'
			);
			$sidebars['displetretsidx-search-form-2'] = array(
				'displetretsidxsearchfield-4',
				'displetretsidxsearchfield-5',
				'displetretsidxsearchfield-6'
			);
			$sidebars['displetretsidx-search-form-advanced-1'] = array(
				'displetretsidxsearchfield-7',
				'displetretsidxsearchfield-8'
			);
			$sidebars['displetretsidx-search-form-advanced-2'] = array(
				'displetretsidxsearchfield-9',
				'displetretsidxsearchfield-10'
			);
		}
		if (empty($sidebars['displetretsidx-quick-search-1-form-1'])) {
			$need_sidebars_update = true;
			$sidebars['displetretsidx-quick-search-1-form-1'] = array(
				'displetretsidxsearchfield-11',
				'displetretsidxsearchfield-12',
				'displetretsidxsearchfield-13',
				'displetretsidxsearchfield-14',
				'displetretsidxsearchfield-15'
			);
		}
		if ($need_sidebars_update) {
			update_option('sidebars_widgets', $sidebars);
		}
    }
    
    function bootstrap(){
        $this_dir = dirname(__FILE__);
        require_once $this_dir . '/displet-load.php';
        require_once $this_dir . '/displet-query.php';
        require_once $this_dir . '/displet-settings.php';
    }
}

add_action('wp_head', array('DispletRetsIdxPlugin', 'add_version'), 1000000);
add_action('init', array('DispletRetsIdxPlugin', 'bootstrap'));
register_activation_hook(__FILE__, array('DispletRetsIdxPlugin', 'register_default_settings'));
register_activation_hook(__FILE__, array('DispletRetsIdxPlugin', 'register_default_widgets'));
register_activation_hook(__FILE__, array('DispletRetsIdxPlugin', 'register_default_widget_areas_content'));

// No code included in files below without add_action hooks
$this_dir = dirname(__FILE__);
require_once $this_dir . '/displet-emails.php';
require_once $this_dir . '/displet-google-login.php';
require_once $this_dir . '/displet-url-structure.php';
require_once $this_dir . '/displet-quick-start.php';
require_once $this_dir . '/displet-search-results.php';
require_once $this_dir . '/displet-shortcodes.php';
require_once $this_dir . '/displet-tinymce.php';
require_once $this_dir . '/displet-users.php';
require_once $this_dir . '/displet-widgets.php';


?>