<script>
jQuery(document).ready(function($){
	$('#displet-leads .displet-lead .displet-user').click(function(){
		var id = $(this).attr('id');
		if ($('#displet-leads .displet-lead-details.' + id).is(':visible')){
			$('#displet-leads .displet-lead-details.' + id).fadeOut();
		}
		else{
			$('#displet-leads .displet-lead-details.' + id).fadeIn();
		}
	});
	$('#displet_delete_selected_users').click(function(){
		var users_array = new Array();
		$('.displetreader.leads table input:checked').each(function(){
			users_array.push($(this).attr('id'))
		});
		if (users_array.length) {
			var confirm = window.confirm('Are you sure you wish to delete the selected users?');
			if (confirm == true){
				var data = {
				    action: 'displet_delete_users_request',
				    _ajax_nonce: '<?php echo wp_create_nonce("displet_delete_users_nonce"); ?>',
				    displet_users: users_array,
				};
				$.post("<?php echo admin_url('admin-ajax.php'); ?>", data, function(response) {
					if (response != 'Succesful Deletion') {
						alert(response);
					}
					window.location.reload();
				});
			}
		}
		else{
			alert('No user has been selected.');
		}
	});
});
</script>
<?php
	// Get settings
	$displetretsidx_option = DispletRetsIdxSettings::get_option();

	// Determine page, query offset, and pagination URLs
	$page = !empty($_GET['pagenum']) ? intval($_GET['pagenum']) : 1;
	$offset = 25 * ($page - 1);
	$unpaged_url = preg_replace('/&pagenum=(\d+)/', '', $_SERVER["REQUEST_URI"]);
	$previous_url = $unpaged_url . '&pagenum=' . ($page - 1);
	$next_url = $unpaged_url . '&pagenum=' . ($page + 1);

	// Get users tagged as leads
	$args = array(
		'meta_key' => 'displet_lead',
		'meta_value' => true,
		'orderby' => 'registered',
		'order' => 'DESC',
		'number' => 25,
		'offset' => $offset
	);
	$leads = get_users($args);
?>
<div class="wrap displetreader leads">
	<h2>Displet Lead Manager</h2>
	<div class="pagination">
		<?php if (!empty($page) && $page != 1) : ?>
			<a href="<?php echo $previous_url; ?>" class="displet-left">Previous Page</a>
		<?php endif; ?>
		<?php if (count($leads) == 25) : ?>
			<a href="<?php echo $next_url; ?>" class="displet-right">Next Page</a>
		<?php endif; ?>
		<div class="displet-clear"><!-- --></div>
	</div>
	<table id="displet-leads">
		<tr>
			<th></th>
			<th>Name</th>
			<th>Email</th>
			<th>Phone</th>
			<th>Price Mean</th>
			<th>Sq Ft Mean</th>
			<th>Zip Mode</th>
		</tr>
		<?php
			if (!empty($leads)) {
				$search_results_url = get_permalink($displetretsidx_option['search_results_page_id']);
				$property_details_url = get_permalink($displetretsidx_option['property_details_page_id']);
				foreach ($leads as $lead) {
					$lead->edit_url = admin_url('user-edit.php?user_id=' . $lead->ID);
					$searches_markup = '';
					if (!empty($lead->displet_user_hashes)) {
						foreach ($lead->displet_user_hashes as $hash) {
							$searches_markup .= '<a href="' . $search_results_url . $hash . '" target="_blank">' . $search_results_url . $hash . '</a><br>';
						}
					}
					$properties_markup = $price_avg = $sq_ft_avg = $zip_mode = '';
					if (!empty($lead->displet_user_properties)) {
						$price_avg = $price_count = $sq_ft_avg = $sq_ft_count = 0;
						foreach ($lead->displet_user_properties as $property) {
							if (!empty($property['url'])){
								$property['address'] = (!empty($property['address'])) ? $property['address'] : 'Property';
								$properties_markup .= '<a href="' . $property_details_url . $property['url'] . '" target="_blank">' . $property['address'] . '</a><br>';
							}
							if (!empty($property['price']) && intval($property['price']) > 0) {
								$price_total += intval($property['price']);
								$price_count++;
							}
							if (!empty($property['sq_ft']) && intval($property['sq_ft']) > 0) {
								$sq_ft_total += intval($property['sq_ft']);
								$sq_ft_count++;
							}
							if (!empty($property['zip'])) {
								$properties_zips[] = $property['zip'];
							}
							if ($price_count > 0) {
								$price_avg = '$' . number_format(intval($price_total / $price_count));
							}
							if ($sq_ft_count > 0) {
								$sq_ft_avg = number_format(intval($sq_ft_total / $sq_ft_count));
							}
							if (!empty($properties_zips)) {
								$values = array_count_values($properties_zips); 
								$zip_mode = array_search(max($values), $values);
							}
						}
					}

					echo
						'<tr class="displet-lead">
							<td><input id="' . $lead->ID . '" type="checkbox"></td>
							<td>' . $lead->nickname . ' <a href="javascript:void(0);" id="displet-lead-' . $lead->ID . '" class="displet-user">(Details)</a></td>
							<td><a href="mailto:' . $lead->user_email . '">' . $lead->user_email . '</a></td>
							<td>' . $lead->displet_phone . '</td>
							<td>' . $price_avg . '</td>
							<td>' . $sq_ft_avg . '</td>
							<td>' . $zip_mode . '</td>
						</tr>
						<tr class="displet-lead-details displet-lead-' . $lead->ID . '">
							<td><!-- --></td>
							<td class="displet-edit-user">
								<a href="' . $lead->edit_url . '">Edit User</a>
							</td>
							<td colspan="7">
								<table class="displet-details">
									<tr>
										<td><label>Last login:</label> ' . $lead->displet_last_login . '</td>
										<td><label>Registered on: </label>' . get_date_from_gmt($lead->user_registered, 'Y/m/d \a\t g:ia') . '</td>
									</tr>
									<tr>
										<td class="url"><label>Registered at:</label> <a href="' . $lead->displet_registration_url . '" target="_blank">' . $lead->displet_registration_url . '</a></td>
										<td class="url"><label>Registered from:</label> <a href="' . $lead->displet_registration_upstream_url . '" target="_blank">' . $lead->displet_registration_upstream_url . '</a></td>
									</tr>
									<tr>
										<td class="url">
											<label>
												Searched for:
											</label>
											' . $searches_markup . '
										</td>
										<td class="url">
											<label>
												Viewed:
											</label>
											' . $properties_markup . '
										</td>
									</tr>
								</table>
							</td>
						</tr>';
				}
			}
			else{
				echo '<tr><td colspan="9">There are no leads at this time.</td></tr>';
			}
		?>
	</table>
	<div class="pagination">
		<?php if (!empty($page) && $page != 1) : ?>
			<a href="<?php echo $previous_url; ?>" class="displet-left">Previous Page</a>
		<?php endif; ?>
		<?php if (count($leads) == 25) : ?>
			<a href="<?php echo $next_url; ?>" class="displet-right">Next Page</a>
		<?php endif; ?>
		<div class="displet-clear"><!-- --></div>
	</div>
	<div class="submit">
		<a href="javascript:void(0);" id="displet_delete_selected_users" class="button-primary">Delete Selected Users</a>
	</div>
	<div class="displet-response"><!-- --></div>
</div>