<?php
	/***************************
	Available Variables:
	$model['options'] = array(); // All fields from settings/settings-page.php
	$model['meta'] = array(
		'first',
		'last',
		'count',
		'limit',
		'page',
		'list_price_min',
		'list_price_max',
		'list_price_mean',
		'square_feet_min',
		'square_feet_max',
		'square_feet_mean'
	);
	***************************/
?>
<div id="displet-stats" class="displet-default-styles displet-<?php echo $model['options']['color_scheme']; ?>-color-scheme<?php if (strtolower($model['show_listings']) != 'no') echo ' displet-with-listings'; ?>">
	<?php if (!empty($model['caption'])) : ?>
		<div class="displet-title displet-font-color">
			<?php echo $model['caption']; ?>
			<span class="displet-prices" style="display: none;">
				$<span class="displet-lowest-price-title"></span>
				to
				$<span class="displet-highest-price-title"></span>
			</span>
		</div>
	<?php endif; ?>
	<table>
		<tr>
			<th scope="row" class="displet-font-color-light">Price Range:</th>
			<td>
				$<span class="displet-lowest-price displet-font-color-light"><?php echo esc_html(number_format($model['meta']->list_price_min)); ?></span>
				to
				$<span class="displet-highest-price displet-font-color-light"><?php echo esc_html(number_format($model['meta']->list_price_max)); ?></span>
			</td>
			<th scope="row" class="displet-font-color-light">Price Average:</th>
			<td>
				$<span class="displet-average-price displet-font-color-light"><?php echo esc_html(number_format(intval($model['meta']->list_price_mean))); ?></span>
			</td>
		</tr>
	<?php if (intval($model['meta']->square_feet_max) > 0) :?>
		<tr>
			<th scope="row" class="displet-font-color-light">Size Range:</th>
			<td>
				<span class="displet-lowest-square-footage displet-font-color-light"><?php echo esc_html(number_format($model['meta']->square_feet_min)); ?></span>
				to
				<span class="displet-highest-square-footage displet-font-color-light"><?php echo esc_html(number_format($model['meta']->square_feet_max)); ?></span>
				Sq. Ft.
			</td>
			<th scope="row" class="displet-font-color-light">Size Average:</th>
			<td>
				<span class="displet-average-square-footage displet-font-color-light"><?php echo esc_html(number_format(intval($model['meta']->square_feet_mean))); ?></span>
				Sq. Ft.
			</td>
		</tr>
	<?php endif ?>
	</table>
	<div class="displet-listings-loading" style="display: none;"><!-- --></div>
</div>